﻿using System;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;

namespace WpfApplication1.ViewModels
{
    public class Pane3ViewModel : ViewModelBase
    {
        #region properties

        public static Pane3ViewModel Instance
        {
            get;
            private set;
        }

        public string ButtonContent
        {
            get;
            private set;
        }

        private String _textInput = "Message Text";

        public string TextInput
        {
            get
            {
                return _textInput;
            }
            set
            {
                if ( _textInput != value )
                {
                    _textInput = value;
                    RaisePropertyChanged(nameof(TextInput));
                }
            }
        }

        private String _labelText = String.Empty;

        public string LabelText
        {
            get
            {
                return _labelText;
            }
            set
            {
                if ( _labelText != value )
                {
                    _labelText = value;

                    RaisePropertyChanged("LabelText");
                }
            }
        }

        #endregion properties

        #region commands

        private RelayCommand _notificationCommand;

        public RelayCommand NotificationCommand
        {
            get
            {
                return _notificationCommand ?? (_notificationCommand = new RelayCommand(() => LabelText = TextInput));
            }
            set
            {
                _notificationCommand = value;
            }
        }

        #endregion commands

        #region constructors

        static Pane3ViewModel()
        {
            Instance = new Pane3ViewModel();
        }

        private Pane3ViewModel()
        {
            ButtonContent = "Notify";
        }

        #endregion constructors
    }
}