﻿using System;
using System.Collections.Generic;
using System.Linq;
using GalaSoft.MvvmLight.Messaging;
using Infragistics.Windows.DockManager;
using Infragistics.Windows.Ribbon;
using WpfApplication1.ViewModels;

namespace WpfApplication1.Views
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class Ribbon : XamRibbon
    {
        #region properties

        public Dictionary<String, Action<String>> ActionList
        {
            get;
            private set;
        }

        #endregion properties

        #region constructor

        public Ribbon()
        {
            InitializeComponent();
            ActionList = new Dictionary<String, Action<String>>();
        }

        #endregion constructor

        #region methods

        public void LinkRibbonTabToContentPane(ContentPane pane1, ContentPane pane2, ContentPane pane3)
        {
            ActionList[pane1.Name] = (message => HandleMessage(message, 0, false));
            ActionList[pane2.Name] = (message => HandleMessage(message, 1, true));
            ActionList[pane3.Name] = (message => HandleMessage(message, 2, true));

            foreach ( var pane in ActionList )
            {
                Messenger.Default.Register<String>(ActionList, pane.Key, pane.Value);
            }
        }

        private void HandleMessage(String message, Int32 index, Boolean selectContextTab)
        {
            if ( message == "Just do it." )
            {
                for ( int i = 0 ; i < ContextualTabGroups.Count ; i++ )
                {
                    ContextualTabGroups[i].IsVisible = (i == index);
                }
                if ( selectContextTab )
                {
                    Rib.SelectNextTab(); // The selected ribbon tab (that is part of the ContextualTabGroup) is displayed in front of any other ribbon tab. (It is a 1-by-1 relationship between a content pane and the associated ribbon tab.)
                }
            }
        }

        #endregion methods
    }
}